//+------------------------------------------------------------------+
//|                                                    1-quadrat.mq4 |
//|                                             Copyright  2008, AP |
//|                                                olgapob33@mail.ru |
//|     Mathemat                              |
/// http://forum.mql4.com/ru/10446/page29                            |
//+------------------------------------------------------------------+
//
//QWMA( i; N ) = 1/(sum(N-i)^2-1) ) * sum( Close[i] * (N-i)^2; i = 0..N-1 ) (   ).
//        Close=0  HLCC=6

#property copyright "Copyright  2008, AP"
#property link      "olgapob33@mail.ru"
#property link "http://forum.mql4.com/ru/10446/page29"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Aqua
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#define max 3000 //- ,      
                     //     ,    Bars

extern int N_Period=8; //1000 <=   QWMA
extern int _Price=0; 


double qWma[],cena[];
double k,N;
double quad[1000];

int first=0;
int init()
  { int i; double sum;

   IndicatorBuffers(2);
   SetIndexBuffer(0,qWma);          
  SetIndexStyle(0,DRAW_LINE);   
   SetIndexDrawBegin(0,N_Period+1);
   
  SetIndexBuffer(1,cena);          
  SetIndexStyle(1,DRAW_NONE);
   
   if(_Price>6) _Price =6;
   if (N_Period>1000) N_Period=1000;
   
   N=N_Period;
   //k=1./( N*(N+1)*(2*(N+1)) ); //*(N+1)
   sum=0;
   for(i=0;i<N_Period;i++)sum+=(N-i)*(N-i);  //  -
   k=1./(sum-1);
   for(i=0;i<N_Period;i++) quad[i]=(N_Period-i)*(N_Period-i); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {    return(0);   }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int i,j,limit;    int    counted_bars=IndicatorCounted();  double sum;
   if(max<Bars) limit=max-counted_bars-1; else limit=Bars-counted_bars-1;
   
   for(i=0;i<limit;i++) cena[i]=iMA(NULL,0,1,0,0,_Price,i);
      for(i=0;i<limit-N_Period;i++) 
      {
      sum=0;
         for (j=0;j<N_Period-1;j++) sum+=cena[i+j]*quad[j];
      qWma[i]=k*sum;
      }
   return(0);
  }
//+------------------------------------------------------------------+